package io.gmss.fiscad.implementations.rfu.parametre;

import io.gmss.fiscad.entities.rfu.parametre.ZoneRfu;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.rfu.parametre.ZoneRfuService;
import io.gmss.fiscad.repositories.rfu.parametre.ZoneRfuRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class ZoneRfuServiceImpl implements ZoneRfuService {
    private final ZoneRfuRepository zoneRfuRepository;

    public ZoneRfuServiceImpl(ZoneRfuRepository zoneRfuRepository) {
        this.zoneRfuRepository = zoneRfuRepository;
    }

    @Override
    public ZoneRfu createZoneRfu(ZoneRfu zoneRfu) throws BadRequestException {
        if (zoneRfu.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle campgne ayant un id non null.");
        }
        return zoneRfuRepository.save(zoneRfu);
    }
    @Override
    public ZoneRfu updateZoneRfu(Long id, ZoneRfu zoneRfu) throws NotFoundException {
        if (zoneRfu.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle zoneRfu ayant un id null.");
        }
        if (!zoneRfuRepository.existsById(zoneRfu.getId())) {
            throw new NotFoundException("Impossible de trouver la zoneRfu spécifiée dans notre base de données.");
        }
        return zoneRfuRepository.save(zoneRfu);
    }

    @Override
    public void deleteZoneRfu(Long id) throws NotFoundException {
        Optional<ZoneRfu> zoneRfuOptional = zoneRfuRepository.findById(id);
        if (zoneRfuOptional.isPresent()) {
            zoneRfuRepository.deleteById(zoneRfuOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la zoneRfu spécifiée dans notre base de données.");
        }
    }
    @Override
    public Page<ZoneRfu> getZoneRfuList(Pageable pageable) {
        return zoneRfuRepository.findAll(pageable);
    }

    @Override
    public List<ZoneRfu> getZoneRfuList() {
        return zoneRfuRepository.findAll();
    }



    @Override
    public Optional<ZoneRfu> getZoneRfuById(Long id) {
        return zoneRfuRepository.findById(id);
    }
}

